#!/bin/sh

pack_file() {
   local bucket="$1" src="$2" target="$3" perms="${4:-0644}" owner=${5:-0:0}
   local bfile="$TEMP_D/buckets"
   {
      echo " - &$bucket |"
      echo '   #!/bin/sh'
      echo "   cat > '$target' <<\"__ENDFILE\""
      sed "s,^,   ," "$src"
      echo "   __ENDFILE"
      echo "   chmod $perms '$target'"
      echo "   chown $owner '$target'"
   } >> "$bfile"
   run_bucket "$bucket"
}

pack_ffile() {
   local bucket="$1" src="$2"
   shift 2
   pack_file "$bucket" "${FILES_D}/$src" "$@"
}

run_bucket() {
   local bucket="$1" user="${2:-root}"
   if [ "$user" = "root" ]; then
      echo " - [ sh, -c, *$bucket ]" >> "$RUNCMDS"
   else
      echo " - [ sudo, -Hu, $user, sh, -c, *$bucket ]" >> "$RUNCMDS"
   fi
}

run_cmd() {
   local tok="" line=""
   line=" - [ "
   for tok in "$@"; do line="${line}\"${tok}\", "; done
   echo "${line%, } ]" >> "$RUNCMDS"
}

send() {
   local proxy=""
   while [ $# -ne 0 ]; do
      cur="$1"; next="$2"
      case "$cur" in
         --apt-proxy=*) proxy="${cur#--apt-proxy=}";;
         --apt-proxy) proxy="$next"; shift;;
      esac
      shift
   done

   echo "#cloud-config"
   echo "output: {all: '| tee -a /var/log/cloud-init-output.log'}"
   if [ -n "$proxy" ]; then
      echo "apt_proxy: $proxy"
   fi
   echo "buckets:"
   cat "$BUCKETS"
   echo "runcmd:"
   cat "$RUNCMDS"
}
